/// <reference types="react" />
import ReactDOM from 'react-dom/client';
declare type ComponentType<T> = (props: T & Required<BaseProps>) => React.ReactElement;
export interface BaseProps {
    open: boolean;
    onClose: () => void;
}
export interface IDialogBuilder<T> {
    component?: ComponentType<T>;
}
declare class Dialog<T> {
    component?: ComponentType<T>;
    props: T;
    viewRoot?: ReactDOM.Root;
    rootId: string;
    constructor(dialogBuilder: IDialogBuilder<T>);
    private createView;
    close(): void;
    withProps(props: (t: Dialog<T>) => Omit<T, 'open'>): this;
    open(): void;
    unmount(): void;
}
export declare class DialogBuilder<T> implements IDialogBuilder<T> {
    component?: ComponentType<T>;
    setComponent(component: ComponentType<T>): this;
    build(): Dialog<T>;
}
export {};
